/* $Id: smm-ecl.pl,v 1.1 1995/09/11 17:47:15 uwe Exp $	*/
/* Kryptoarithmetische Rtsel gelst mit constraint logic programming */
/* mit ECLiPSe von ECRC */

/*--------------------------------------------------------------*/

/*      S E N D							*/
/*  +   M O R E							*/
/*  -----------							*/
/*  = M O N E Y							*/

/*--------------------------------------------------------------*/

/* Konstruktion der Variablen					*/
/* send(-DL,+Base)						*/
/*	DL	Variablenliste					*/
/*	Base	Basis des Zahlensystems 			*/

/*--------------------------------------------------------------*/

:- use_module(library(fd)).

mkvariables(DL,Base) :-
	Base1 is Base - 1,
						% Ziffernliste
	DL = [S,E,N,D,M,O,R,Y],
						% einschrnken auf gltige Ziffern
	DL :: 0 .. Base1,
						% bertrge
	UE = [U1,U2,U3,U4],
						% einschrnken auf 0 oder 1
	UE :: 0 .. 1,
						% Ziffern paarweise verschieden
	alldistinct(DL),
						% fhrende Ziffern \= 0	*/
	S :: 1..Base1,
	M :: 1..Base1,
						% 1. Spalte
	D + E      #= Base * U1 + Y,
						% 2. Spalte
	N + R + U1 #= Base * U2 + E,
						% 3. Spalte
	E + O + U2 #= Base * U3 + N,
						% 4. Spalte
	S + M + U3 #= Base * U4 + O,
						% 5. Spalte
		U4 #=           M.

% ------------------------------------------------------------------------------

labelingseq([]).

labelingseq([H | R]) :-
	indomain(H),
	labelingseq(R).

labelingff([]) :- !.

labelingff(List) :-
	deleteff(Var, List, RestList),
	indomain(Var),
	labelingff(RestList).

% ------------------------------------------------------------------------------

solve(DL,Base) :-
	mkvariables(DL,Base),
	labelingseq(DL).

out(DL) :-
	nl,
	write('[S,E,N,D,M,O,R,Y] = '),
	write(DL),nl.

send(Base) :-
	nl,
	write('send+more=money zur Basis '),
	write(Base),nl,
	solve(DL,Base),
	out(DL).

send :-
	send(10).

send11 :-
	send(11).

send16 :-
	send(16).

/*--------------------------------------------------------------*/

allsolutions(Base,L) :-
	findall(DL,solve(DL,Base),L).

noofsolutions(Base,N) :-
	allsolutions(Base,L),
	length(L,N).


nos16 :-
	nl,
	write('send+more=money zur Basis 16'),nl,
	noofsolutions(16,N),
	write('# Lsungen = '),write(N),nl.

/*--------------------------------------------------------------*/

/*    D O N A L D						*/
/*  + G E R A L D						*/
/*  --------------						*/
/*  = R O B E R T						*/

donald(LD):-
        LD = [D, O, N, A, L, G, E, R, B, T],
	LD :: 0 .. 9,
	alldistinct(LD),
        [D, G, R] :: 1..9,

           100000 * D + 10000 * O + 1000 * N + 100 * A + 10 * L + D
        +  100000 * G + 10000 * E + 1000 * R + 100 * A + 10 * L + D
        #= 100000 * R + 10000 * O + 1000 * B + 100 * E + 10 * R + T.

donald :-
	write('donald+gerald=robert : normale suche'),nl,

	cputime(Start),

	donald(LD),
	labelingseq(LD),

	cputime(Stop),

	write('[D,O,N,A,L,G,E,R,B,T] = '),write(LD),nl,
	Time is Stop - Start, write('Zeit : '), write(Time), write(' sec.'), nl.

donaldff :-
	write('donald+gerald=robert : first fail Heuristik'),nl,

	cputime(Start),

        donald(LD),
        labelingff(LD),

	cputime(Stop),

        write('[D,O,N,A,L,G,E,R,B,T] = '),write(LD),nl,
	Time is Stop - Start, write('Zeit : '), write(Time), write(' sec.'), nl.


/*--------------------------------------------------------------*/

