/* $Id: smm.pl,v 1.1 1995/12/20 11:52:26 uwe Exp $	*/
/* Kryptoarithmetische Rtsel gelst mit constraint logic programming */
/* mit clp(FD) Prolog von INRIA */

/*--------------------------------------------------------------*/

/*      S E N D							*/
/*  +   M O R E							*/
/*  -----------							*/
/*  = M O N E Y							*/

/*--------------------------------------------------------------*/

/* Konstruktion der Variablen					*/
/* send(-DL,+Base)						*/
/*	DL	Variablenliste					*/
/*	Base	Basis des Zahlensystems 			*/

/*--------------------------------------------------------------*/

mkvariables(DL,Base) :-
	Base1 is Base - 1,
				/* Ziffernliste			*/
	DL = [S,E,N,D,M,O,R,Y],
				/* bertrge			*/
	UE = [U1,U2,U3,U4],
				/* Ziffern paarweise verschieden*/
	alldifferent(DL),
				/* mgliche Ziffern		*/
	domain(DL,0,Base1),
				/* mgliche bertrge		*/
	domain(UE,0,1),
				/* fhrende Ziffern \= 0	*/
	S in 1..Base1,
	M in 1..Base1,
					/* 1. Spalte		*/
	D + E      #= Base * U1 + Y,
					/* 2. Spalte		*/
	N + R + U1 #= Base * U2 + E,
					/* 3. Spalte            */
	E + O + U2 #= Base * U3 + N,
					/* 4. Spalte		*/
	S + M + U3 #= Base * U4 + O,
					/* 5. Spalte		*/
		U4 #=           M.

/*--------------------------------------------------------------*/

solve(DL,Base) :-
	mkvariables(DL,Base),
	labeling(DL).

out(DL) :-
	nl,
	write('[S,E,N,D,M,O,R,Y] = '),
	write(DL),nl.

send(Base) :-
	nl,
	write('send+more=money zur Basis '),
	write(Base),nl,
	solve(DL,Base),
	out(DL).

send :-
	send(10).

send11 :-
	send(11).

send16 :-
	send(16).

/*--------------------------------------------------------------*/

allsolutions(Base,L) :-
	findall(DL,solve(DL,Base),L).

noofsolutions(Base,N) :-
	allsolutions(Base,L),
	length(L,N).


nos16 :-
	nl,
	write('send+more=money zur Basis 16'),nl,
	noofsolutions(16,N),
	write('# Lsungen = '),write(N),nl.

/*--------------------------------------------------------------*/

/*    D O N A L D						*/
/*  + G E R A L D						*/
/*  --------------						*/
/*  = R O B E R T						*/

donald(LD):-
        LD=[D,O,N,A,L,G,E,R,B,T],
        alldifferent(LD),
        domain(LD,0,9),
        D in 1..9,
        G in 1..9,

           100000*D+10000*O+1000*N+100*A+10*L+D +
           100000*G+10000*E+1000*R+100*A+10*L+D
        #= 100000*R+10000*O+1000*B+100*E+10*R+T.

donald :-
	write('donald+gerald=robert : normale suche'),nl,
	statistics(runtime,_),
	donald(LD),
	labeling(LD),
	statistics(runtime,[_,Y]),
	write('[D,O,N,A,L,G,E,R,B,T] = '),write(LD),nl,
	write('Zeit : '),write(Y),nl,
	!.

donaldff :-
	write('donald+gerald=robert : first fail Heuristik'),nl,
	statistics(runtime,_),
        donald(LD),
        labelingff(LD),
	statistics(runtime,[_,Y]),
        write('[D,O,N,A,L,G,E,R,B,T] = '),write(LD),nl,
	write('Zeit : '),write(Y),nl,
	!.                                 


/*--------------------------------------------------------------*/

